<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import VueDraggableResizable from '@/components/freeform/VueDraggableResizable.vue';
import { storeToRefs } from 'pinia';
import { computed, ref, onMounted, watch } from 'vue';
import type { Ref } from 'vue';
import { useFreeformStore } from '@/stores/freeform';
import ElementDropdown from '@/components/freeform/ElementDropdown.vue';
import Embedded from '@/components/general/Embedded.vue';
import TextView from '@/components/general/TextView.vue';
import { handleModeEnum, userType } from '@/enums/enums';
import useFreeform from '@/hooks/useFreeform';
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';
import { getFileType, convertRemToPixels } from '@/lib/utils';
import MagnifiedPost from '@/components/general/MagnifiedPost.vue';

const props = defineProps<{
    post: any,
    postIndex: number
}>();

const store = useFreeformStore();
const { getMovable, getFullUsable, getCommentsAllowed, startID, endID, handleMode, isRnD, getStyle, elementId, elementTitle, elementText, elementInfo, elementBody, postIndex, lineMovingTime, getUserType, elementColor, showComments } = storeToRefs(store);
const methods = useFreeform();
const isResizing = ref(false);

const getLockRatio = computed(() => {
    return props.post.body ? true : false
});

const topLocal: any = ref(null);
const leftLocal: any = ref(null);
const widthLocal: any = ref(null);
const heightLocal: any = ref(null);
const calculatedHeight = ref(0);

const handle: Ref<HTMLElement | null> = ref(null);
const element: Ref<HTMLElement | null> = ref(null);

const localRnD = ref(false);


const getY = computed(() => {
    /*if (topLocal.value) {
        return Number(topLocal.value);
    } else {
        if (props.post && props.post.styleObject && typeof props.post.styleObject.top === "string") {
            let y = Number(props.post.styleObject.top.replace("px", ""));
            return y;
        } else {
            return props.post.styleObject.top;
        }
    }*/
    if (props.post && props.post.styleObject && typeof props.post.styleObject.top === "string") {
        let y = Number(props.post.styleObject.top.replace("px", ""));
        return y;
    } else {
        return props.post.styleObject.top;
    }
});

const getX = computed(() => {
    /*if (leftLocal.value) {
        return Number(leftLocal.value);
    } else {
        
    }*/
    if (props.post && props.post.styleObject && typeof props.post.styleObject.left === "string") {
        let x = Number(props.post.styleObject.left.replace("px", ""));
        return x;
    }
    else {
        return props.post.styleObject.left;
    }
});

const getWidth = computed(() => {
    if (widthLocal.value) {
        return Number(widthLocal.value);
    } else {
        if (props.post.size && props.post.size.width)
            return Number(props.post.size.width);
        else
            return 150;
    }
});

const getHeight = computed(() => {
    if (heightLocal.value) {
        return Number(heightLocal.value);
    } else {
        if (props.post.size && props.post.size.height) {
            return Number(props.post.size.height);
        }
        else
            return 100;
    }
});


const onDragHandle = () => {
    lineMovingTime.value = +new Date();
};

const onResizeHandle = (elem: any, left: number, top: number, width: number, height: number) => {
    // remove 2 rem when embedded because of the -2rem of the topbar margin
    calculatedHeight.value = handle.value!.offsetHeight + 70 - (showTopbar.value ? convertRemToPixels(2) : 0);
    heightLocal.value = calculatedHeight.value;
    leftLocal.value = left;
    topLocal.value = top;
    widthLocal.value = Math.round(width);
    lineMovingTime.value = +new Date();

};

const onResizeEndHandle = (left: number, top: number, width: number, height: number) => {
    //let newHeight = Math.max(handle.value!.offsetHeight,height);
    store.editPostPosition({ postIndex: props.postIndex, top: String(top), left: String(left), height: height, width: width });
    heightLocal.value = null;
    widthLocal.value = null;
};

const onDragStartHandle = () => {
    isRnD.value = true;
    localRnD.value = true;
};

const onDragEndHandle = (left: number, top: number) => {
    //leftLocal.value = null;
    //topLocal.value = null;
    widthLocal.value = null;
    heightLocal.value = null;
    isRnD.value = false;
    localRnD.value = false;
    // remove 2 rem when embedded because of the -2rem of the topbar margin
    let height = handle.value!.offsetHeight + 70 - (showTopbar.value ? convertRemToPixels(2) : 0);
    let width = handle.value!.offsetWidth;
    store.editPostPosition({ postIndex: props.postIndex, top: String(top), left: String(left), height: Math.floor(height), width: Math.floor(width) }); //TODO: check against side effects
};

const addLineHandle = () => {
    if (props.post.id && props.post.authorized) {
        if (startID.value) {
            endID.value = props.post.id;
            if (startID.value === endID.value) {
                startID.value = '';
                endID.value = '';
            }
            else {
                if (endID.value) {
                    if (getStyle.value.lineText === "true" || getStyle.value.lineText === true) {
                        showAddLineModal(true);
                    } else {
                        addLine();
                    }
                }
            }
        }
    }
}

const initializeAddLineHandle = () => {
    if (props.post.id) {
        if (!startID.value) {
            startID.value = props.post.id;
        }
    }
}

const addLine = () => {
    store.createLine({
        start: startID.value, end: endID.value,
        text: lineText.value, dash: getStyle.value.lineStyle.dash, color: getStyle.value.lineStyle.color
    });
    cancelAddLine();

}

const cancelAddLine = () => {
    showAddLineModal(false);
    startID.value = '';
    endID.value = '';
}

const editPost = () => {
    elementId.value = props.post.id;
    elementText.value = props.post.title.post;
    elementTitle.value = props.post.title.headline;
    elementInfo.value = props.post.info;
    elementBody.value = props.post.body;
    elementColor.value = props.post.color;
    handleMode.value = handleModeEnum.EDIT;
}

const sizeCalculation = () => {
    let currentWidth = element.value?.offsetWidth;
    // remove 2 rem when embedded because of the -2rem of the topbar margin
    calculatedHeight.value = (handle.value?.offsetHeight ?? 80)  + 70 - (showTopbar.value ? convertRemToPixels(2) : 0);
    let height = calculatedHeight.value;
    if (((props.post.size && props.post.size.height !== height) || (props.post.size === undefined) && currentWidth)) {
        store.editPostProps({ postIndex: props.postIndex, height: Math.floor(height), width: Math.floor(currentWidth!) });
        elementId.value = '';
    }
}

const openCommentCanvas = () => {
    postIndex.value = props.postIndex;
    showComments.value = true;
};

const resizeCalculation = () => {
    setTimeout(() => { sizeCalculation() }, 100);
};

onMounted(resizeCalculation);

watch(() => [getStyle.value.fontSize, props.post.info, props.post.body, props.post.title, props.post.size],  resizeCalculation, { deep: true });

const imgLoaded = () => {
    resizeCalculation();
};

const lineText = ref('.');
const isAddLineModalOpen = ref(false);
const showAddLineModal = (value: boolean) => {
    isAddLineModalOpen.value = value;
}

const getCommentsLength = computed(() => {
    if (getUserType.value === userType.ADMIN || getUserType.value === userType.MODERATOR) {
        return props.post.comments.length;
    } else {
        return props.post.comments.filter((comment: any) => comment.visible).length;
    }
});

const changeVisibility = (value: boolean) => {
    store.editPostProps({ postIndex: props.postIndex, visible: value });
};


const isRejectDeleteModal = ref(false);
const showRejectDeleteModal = (value: boolean) => {
    isRejectDeleteModal.value = value;
}

const rejectAuthorization = () => {
    store.deletePost({ postIndex: props.postIndex, postId: props.post.id });
};

const showTopbar = computed(() => {
    if (props.post.body) {
        if (props.post.title.post.toLowerCase().endsWith('.pdf'))
            return true;
        const fileType = getFileType(props.post.body, props.post.title.post);
        return (fileType && fileType !== 'misc' && fileType !== 'h5p') || (props.post.body.image && props.post.body.logo);
    }
    return false;
});


const handleRef = ref<HTMLElement | null>(null);

const isMagnifiedPostOpen = ref(false);
const handleShowMagnifiedPost = (value: boolean) => {
    isMagnifiedPostOpen.value = value;
};

const handleResetLocalRnD = ()=>{
    localRnD.value = false;
};

/*watch(()=>props.post.size, (newVal, oldVal)=>{
    const localNewVal = JSON.parse(JSON.stringify(newVal));
    const localOldVal = JSON.parse(JSON.stringify(oldVal));
});*/


</script>
<template>
    <VueDraggableResizable :draggable="getMovable" :resizable="getFullUsable" :lock-aspect-ratio="false"
        :drag-handle="'#handle_' + post.id" @dragging="onDragHandle" @dnd-stop="handleResetLocalRnD" :onResize="onResizeHandle"
        @resize-stop="onResizeEndHandle" @drag-stop="onDragEndHandle" :onDragStart="onDragStartHandle"
        :min-height="calculatedHeight" :w="getWidth" :h="getHeight" :x="getX" :y="getY" :z="props.postIndex + 2"
        class-name-handle="handle-resize" :class-name-resizing="`outline outline-2 outline-red-700 ${post.shape}`"
        :key="post.id"
        class="box-border rounded-lg bg-white text-gray-500 shadow-md absolute block min-h-20 min-w-[150px] select-none h-full"
        :id="post.id" @click.native="addLineHandle" @contextmenu.prevent=""
        :style="[{ width: getWidth + 'px' }, { background: post.color }, { border: isResizing ? 'solid 1px red' : '' }]"
        :class="[post.shape, { 'outline outline-red-500': (post.id == startID || post.id == endID) }, { 'shadow-md': handleMode !== handleModeEnum.EDIT }, { 'outline-4 outline-dashed outline-red-500': !props.post.visible }, { 'shadow-lg animate-element-wiggle': localRnD }]"
        v-if="((getUserType === userType.USER && (props.post.visible && props.post.authorized)) || (getUserType !== userType.USER))">
        <div ref="element" class="flex flex-col gap-1 justify-stretch h-full">
            <div class="min-h-7 max-h-7 flex flex-row px-2 z-10 relative" ref="handleRef" :id="'handle_' + post.id"
                :class="['tb-' + post.shape, { 'draggable cursor-grab': getFullUsable }, { 'bg-white/80': showTopbar }]">
                <div class="min-h-7 p-1 hyphens-auto w-full max-h-7 text-ellipsis line-clamp-1">
                    <strong>{{ post.title.headline }}</strong>
                </div>
                <div class="ml-auto flex flex-row gap.0.5">
                    <Tooltip :tooltip="$t('tooltips.expandPost')">
                        <button class="rounded-md hover:bg-gray-100 px-1 w-7 text-lg"
                            @click="() => handleShowMagnifiedPost(true)"><i
                                class="ri-expand-diagonal-line"></i></button>
                    </Tooltip>
                    <ElementDropdown :color="post.color" :shape="post.shape" :post="post" :postIndex="props.postIndex"
                        @edit="editPost" v-if="getFullUsable"/>
                </div>
            </div>
            <div class="grow">
                <div ref="handle">
                    <div v-if="post.title.post && !post.body">
                        <TextView :fontSize="getStyle.fontSize" :content="post.title.post" @dblclick="editPost"
                            v-if="getFullUsable" :font-style="getStyle?.font ? getStyle.font : ''" hideHyphens
                            :content-length="-1" />
                        <TextView :fontSize="getStyle.fontSize" :content="post.title.post" hideHyphens v-else
                            :font-style="getStyle?.font ? getStyle.font : ''" :content-length="-1" />
                    </div>
                    <div class="-mt-8" v-else>
                        <Embedded :key="post.title.post" :body="post.body" :url="post.title.post"
                            :fontSize="getStyle.fontSize" :info="post.info" @loaded="imgLoaded"
                            :topbarClass="'tb-' + post.shape" />
                    </div>
                </div>
            </div>
            <div v-if="!startID" class="flex flex-row justify-between p-1">
                <div class="w-fit">
                    <Tooltip :tooltip="$t('contentPage.comment.label.pl')" v-if="getCommentsAllowed">
                        <button class="h-7 p-1 hover:bg-gray-100 select-none flex flex-row rounded-md"
                            @click="openCommentCanvas">
                            <i class="ri-discuss-line leading-5 text-[20px]"></i>
                            <span class="text-xs leading-7 align-bottom"
                                v-if="getCommentsLength <= 99 && getCommentsLength > 0">{{
                                    getCommentsLength }}</span>
                            <span class="text-xs leading-7 align-bottom" v-else-if="getCommentsLength > 99">99+</span>
                        </button>
                    </Tooltip>
                </div>
                <div class="w-fit">
                    <Tooltip :tooltip="$t('tooltips.unhide')"
                        v-if="(getUserType !== userType.USER && !props.post.visible)">
                        <button class="size-7 p-1 hover:bg-gray-100 rounded-md" @click="changeVisibility(true)"><i
                                class="ri-eye-off-line leading-5 text-[20px] text-teal-500"></i></button>
                    </Tooltip>
                </div>
                <div class="w-fit">
                    <Tooltip :tooltip="$t('tooltips.connectPost')" v-if="getFullUsable && !startID">
                        <button class="size-7 p-1 hover:bg-gray-100 rounded-md" @mouseup="initializeAddLineHandle"
                            @touchend.stop.prevent="initializeAddLineHandle"><i
                                class="ri-arrow-right-line leading-5 text-[20px]"></i></button>
                    </Tooltip>
                </div>
            </div>
        </div>
    </VueDraggableResizable>
    <Modal v-if="isAddLineModalOpen" :header="$t('contentPage.lineText')" :labelCancel="$t('general.buttons.cancel')"
        @cancel="cancelAddLine" :labelSubmit="$t('adjustPanel.submit')" @submit="addLine"
        :font="getStyle?.font ? getStyle.font : ''">
        <Input type="text" v-model="lineText" :placeholder="$t('contentPage.lineText')"
            :label="$t('contentPage.lineText')" />
    </Modal>
    <Modal :labelSubmit="$t('adminMenu.pageDelete.submit')" :labelCancel="$t('general.buttons.cancel')"
        @submit="rejectAuthorization" @cancel="showRejectDeleteModal(false)" :text="$t('contentPage.post.deletePost')"
        :font="getStyle?.font ? getStyle.font : ''" v-if="isRejectDeleteModal"></Modal>
    <MagnifiedPost v-if="isMagnifiedPostOpen" @close="() => handleShowMagnifiedPost(false)" :post="post"
        @comments="openCommentCanvas" @visibility="changeVisibility" type="Freeform" :inert="postIndex >= 0"
        :postIndex="props.postIndex" />
</template>
<style scoped>
.animate-element-wiggle {
    animation: wiggle 1.5s linear ;
}

@keyframes wiggle {

    0%,
    7% {
        transform: rotateZ(0);
    }

    15% {
        transform: rotateZ(-5deg);
    }

    20% {
        transform: rotateZ(3deg);
    }

    25% {
        transform: rotateZ(-3deg);
    }

    30% {
        transform: rotateZ(2deg);
    }

    35% {
        transform: rotateZ(-1deg);
    }

    40%,
    100% {
        transform: rotateZ(0);
    }
}
</style>